<?php

class CallBack extends Module
{
// Include extra form fields and/or submitter data?
// false = do not include
	private $extra = array();
    private $to;

	function __construct()
	{
		$this->name = 'callback';
		$this->tab = 'front_office_features';
		$this->version = 1.0;
		$this->author = 'frozzen';
//		$this->need_instance = 0;

		parent::__construct();

		$this->displayName = $this->l('CallBack block');
		$this->description = $this->l('Adds a block for CallBack.');
	}

	function install()
	{
		Configuration::updateValue('FRCALLBACK_EMAIL', 'test@mail.com');
		Configuration::updateValue('FRCALLBACK_ESUBJ', 'CALL-BACK');
		return (parent::install() AND $this->registerHook('top') AND $this->registerHook('header'));
	}

	function uninstall()
	{
		if (!Configuration::deleteByName('FRCALLBACK_EMAIL') 
        OR !Configuration::deleteByName('FRCALLBACK_ESUBJ')
        OR !parent::uninstall())
			return false;
		return true;
	}

	public function getContent()
	{
		$output = '<h2>'.$this->displayName.'</h2>';
		if (Tools::isSubmit('submitFrCallBackEMail') AND ($gai = Tools::getValue('frCallBack_EMail')))
		{
			$gai = htmlentities($gai, ENT_COMPAT, 'UTF-8');
			Configuration::updateValue('FRCALLBACK_EMAIL', $gai);
   		    Configuration::updateValue('FRCALLBACK_ESUBJ', Tools::getValue('frCallBack_ESubj'));
			$output .= '
			<div class="conf confirm">
				<img src="../img/admin/ok.gif" alt="" title="" />
				'.$this->l('Settings updated').'
			</div>';
		}
		return $output.$this->displayForm();
	}

	public function displayForm()
	{
		$output = '
		<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
			<fieldset><legend>'.$this->l('Settings').'</legend>

<label for="frCallBack_EMail">'.$this->l('CallBack e-Mail').'</label>
				<div class="margin-form"><input type="text" size="20" id="frCallBack_EMail" name="frCallBack_EMail" value="'.Configuration::get('FRCALLBACK_EMAIL').'" /></div>

<label for="frCallBack_Esubj">'.$this->l('e-Mail Subject').'</label>
				<div class="margin-form"><input type="text" size="20" id="frCallBack_ESubj" name="frCallBack_ESubj" value="'.Configuration::get('FRCALLBACK_ESUBJ').'" /></div>

				<center><input type="submit" name="submitFrCallBackEMail" value="'.$this->l('Update settings').'" class="button" /></center>			
			</fieldset>
		</form>';
		return $output;
	}

	function hookTop($params)
	{
		
		return $this->display(__FILE__, 'callback.tpl');
	}
	
	function hookHeader($params)
	{
		Tools::addCSS($this->_path.'callback.css', 'screen');
		Tools::addJS(($this->_path).'callback.js');
		Tools::addJS(($this->_path).'jquery.simplemodal.js');
	}

function smcf_token($s) {
        return md5("smcf-" . $s . date("WY"));
}

    public function show_form() {
		global $smarty;

$this->extra = array(
"form_subject"      => false,
"form_cc"           => false,
"ip"                => true,
"user_agent"        => false
);

   	   $smarty->assign('extra', $this->extra);
   	   $smarty->assign('to', $this->smcf_token(Configuration::get('FRCALLBACK_EMAIL')));

		echo $this->display(__FILE__, 'callback_form.tpl');
    }


    public function send_request() {
        // Send the phone

$this->extra = array(
"form_subject"      => false,
"form_cc"           => false,
"ip"                => true,
"user_agent"        => false
);


$this->to = Configuration::get('FRCALLBACK_EMAIL');

$subject = Configuration::get('FRCALLBACK_ESUBJ'); 

        $name = isset($_POST["name"]) ? $_POST["name"] : "";
        $phone = isset($_POST["phone"]) ? $_POST["phone"] : "";
        $subject = isset($_POST["subject"]) ? $_POST["subject"] : $subject;
        $message = isset($_POST["message"]) ? $_POST["message"] : "";
        $cc = isset($_POST["cc"]) ? $_POST["cc"] : "";
        $token = isset($_POST["token"]) ? $_POST["token"] : "";

        // make sure the token matches
        if ($token === $this->smcf_token($this->to)) {
                $this->smcf_send($name, $phone, $subject, $message, $cc);
                echo $this->display(__FILE__, 'callback_ok.tpl');
        }
        else {
                echo $this->display(__FILE__, 'callback_erno.tpl');
        }

}

function smcf_send($name, $phone, $subject, $message, $cc) {


include_once(_PS_SWIFT_DIR_.'Swift.php');

        // Filter and validate fields
        $name = $this->smcf_filter($name);
        $subject = $this->smcf_filter($subject);
        $phone = $this->smcf_filter($phone);
        if (!$this->smcf_validate_phone($phone)) {
                $subject .= " - Warning!: CALL-BACK!";
                $message .= "\n\nНомер телефона: ".$phone;
                $phone = $to;
                $cc = 0; // do not CC "sender"
        }

        // Add additional info to the message
      
		if ($this->extra["ip"]) {
                $message .= "\n\nIP: " . $_SERVER["REMOTE_ADDR"];
        }
        if ($this->extra["user_agent"]) {
                $message .= "\n\nUSER AGENT: " . $_SERVER["HTTP_USER_AGENT"];
        }

        // Set and wordwrap message body
        $body = "Имя: $name\n\n";
        $body = " Телефон: $phone\n\n";
        $body .= " Сообщение: $message";
        $body = wordwrap($body, 70);

        // Build header
        $headers = "From: $phone\n";
        if ($cc == 1) {
                $headers .= "Cc: $phone\n";
        }

        // UTF-8
       //if (function_exists('mb_encode_mimeheader')) {
       //$subject = mb_encode_mimeheader($subject, "UTF-8", "Q", "\n");
       //}
        else {
                // you need to enable mb_encode_mimeheader or risk
                // getting phones that are not UTF-8 encoded
        }
        $headers .= "MIME-Version: 1.0\n";
        $headers .= "Content-type: text/plain; charset=utf-8\n";
        $headers .= "Content-Transfer-Encoding: quoted-printable\n";

        // Send phone

		$configuration = Configuration::getMultiple(array('PS_SHOP_EMAIL', 'PS_MAIL_METHOD', 'PS_MAIL_SERVER', 'PS_MAIL_USER', 'PS_MAIL_PASSWD', 'PS_SHOP_NAME', 'PS_MAIL_SMTP_ENCRYPTION', 'PS_MAIL_SMTP_PORT', 'PS_MAIL_METHOD', 'PS_MAIL_TYPE'));

		if (!isset($configuration['PS_MAIL_SMTP_ENCRYPTION'])) $configuration['PS_MAIL_SMTP_ENCRYPTION'] = 'off';
		if (!isset($configuration['PS_MAIL_SMTP_PORT'])) $configuration['PS_MAIL_SMTP_PORT'] = 25;

$fromName = $phone;
		if (!isset($from)) $from = $configuration['PS_SHOP_EMAIL'];
		if (!isset($fromName)) $fromName = $configuration['PS_SHOP_NAME'];

	$from = new Swift_Address($from, $fromName);

  $smtpChecked = ($configuration['PS_MAIL_METHOD'] == 2);

  $result = Mail::sendMailTest(Tools::htmlentitiesUTF8($smtpChecked), Tools::htmlentitiesUTF8($configuration['PS_MAIL_SERVER']), Tools::htmlentitiesUTF8($body), Tools::htmlentitiesUTF8($subject), Tools::htmlentitiesUTF8('text/html'), Tools::htmlentitiesUTF8($this->to), $from, Tools::htmlentitiesUTF8($configuration['PS_MAIL_USER']), Tools::htmlentitiesUTF8($configuration['PS_MAIL_PASSWD']), Tools::htmlentitiesUTF8($configuration['PS_MAIL_SMTP_PORT']), Tools::htmlentitiesUTF8($configuration['PS_MAIL_SMTP_ENCRYPTION']));

if (!$result) {
echo $this->display(__FILE__, 'callback_die.tpl');

}
//die($result ? '' : echo $this->display(__FILE__, 'callback_die.tpl'));

}

function smcf_filter($value) {
        $pattern = array("/\n/","/\r/","/content-type:/i","/to:/i", "/from:/i", "/cc:/i");
        $value = preg_replace($pattern, "", $value);
        return $value;
}

// Validate phone address format in case client-side validation "fails"
function smcf_validate_phone($phone) {

        // Make sure there aren't multiple periods together
        //if (!preg_match("/^[0-9]{5,20}$/", $phone))
          //      return false;
                
          return true;
              
                }


}


